<?php
/*

Last.Fabchannel

A demo page for a recommender system using the Fabchannel.com concert player.
Too bad, FabPlayer does not like not being on fabchannel.com...

TODO:
Joris:
- Obtain a list of artists with concerts on Fabchannel

Mirjam:
- Add the list of artist with concerts on FabChannel in an array or so.
- Filter the result of loadProfile and loadArtist with FabChannel concerts
Note: Might have more than one concert per artist?

Matthijs: 
- Add autocomplete for artists with the artist available on FabChannel
Note: You'll need the data from Mirjam, but might get started on the technique?
Hint: There is already a onKeyDown call in the input field, maybe you can
		make this a javascript function call?

Created 12 november 2007

Joris Bootsman
Daan Odijk
Mirjam ter Linden
Matthijs Volkers

*/

require ('xajax/xajax.inc.php');

// loadProfile is an AJAX function for loading the topartists for a user
function loadProfile($user) {
	// Make an object that is used to return a response
	$objResponse = new xajaxResponse();

	$url = "http://ws.audioscrobbler.com/1.0/user/$user/topartists.xml"; 

	// Next line is needed because warning when loading xml for 
	//	unknown user messes the xajaxResponse up. 
	error_reporting(1);
	// Works only in PHP5
	$xml = simplexml_load_file("$url");
	
	if(!$xml) {
		// simplexml_load_file returns false in case of an error
		$objResponse->addScript("alert('User not found');");
	} else {
		// Top artists loaded, so build a response
		$text = "Top artists for ".$user.":<br />\n";
		foreach($xml->artist as $artist) {
			// TODO: if($artist in $fabchannelArtists) ???
			$url = 'javascript:xajax_loadArtist("'.$artist->name.'");void(0);';
   		$text .= "<a href='$url'>$artist->name</a><br />\n"; 
		} 
		
		// Assign the list of artists to the div with id artists
		$objResponse->addAssign("artists","innerHTML",$text);
	}
	
	return $objResponse;
}

function loadArtist($artist) {
	// Make an object that is used to return a response
	$objResponse = new xajaxResponse();

	$url = "http://ws.audioscrobbler.com/1.0/artist/$artist/similar.xml"; 

	// Next line is needed because warning when loading xml for unknown
	// artist messes the xajaxResponse up. 
	error_reporting(1);
	// Works only in PHP5
	$xml = simplexml_load_file("$url");
	
	if(!$xml) {
		// simplexml_load_file returns false in case of an error
		$objResponse->addScript("alert('Artist not found');");
	} else {
		// Similar artists loaded, so build a response
		$text = "Similar to ".$artist.":<br />\n";
		foreach($xml->artist as $artist) {
			// TODO: if($artist in $fabchannelArtists) ???
			$url = 'javascript:xajax_loadArtist("'.$artist->name.'");void(0);';
   		$text .= "<a href='$url'>$artist->name</a><br />\n"; 
		} 
		
		// Assign the list of artists to the div with id artists
		$objResponse->addAssign("artists","innerHTML",$text);
	}
	
	return $objResponse;
}

// Instantiate the xajax object.  
// No parameters defaults requestURI to this page, method to POST, and debug to off
$xajax = new xajax(); 

//$xajax->debugOn(); // Uncomment this line to turn debugging on

// Specify the PHP functions to wrap. 
// The JavaScript wrappers will be named xajax_functionname
$xajax->registerFunction("loadProfile");
$xajax->registerFunction("loadArtist");

// Process any requests.  Because our requestURI is the same as our html page,
// this must be called before any headers or HTML output have been sent
$xajax->processRequests();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Last.Fabchannel.com - Personal live concert videos</title>
<script type="text/javascript" src="http://www.fabchannel.com/fab2007/csjs/swfobject.js"></script>

<?php $xajax->printJavascript('xajax/'); ?>

<script type="text/javascript">
<!---
	var D = document;

	function windowOpener(url) {
		var w = 400;
		var h = 410;
		var win = window.open(url,'Popup','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width='+w+',height='+h+',top=100');
		win.focus();
	}

	function setBackground(color) {
		D.bgColor = color;
	}

	/*
	function removeSpaces(string) {
		var tstring = "";
		string 		= '' + string;
		splitstring = string.split(" ");
		for(i = 0; i < splitstring.length; i++)
		tstring += splitstring[i];
		return tstring;
	}
	*/

	function flashcounter(ns_flashn) {
	}

	function doneLoading() {
	}

	function onChangeAd() {
	}
//-->
</script>

<style type="text/css">

	/* hide from ie on mac */
	html {
		height: 100%;
		/*overflow: hidden;*/
	}

	#flashcontent {
		height: 100%;
	}
	/* end hide */

	body {
		background-color: #ffffff;
		height: 100%;
		margin: 0;
		padding: 0;
	}
	
	#recommendations {
		font-size: 10pt;
	}
	#artists {
		overflow: auto;
		height: 573px;
		padding-right: 3px;
	}

</style>

</head>

<body>

	<table width="1005" border="0" style="height:605" align="center">
	<tr>
		<td width="805" style="vertical-align:top;padding-right:15px;padding-top:15px">
			<div id="flashcontent" align="center" style="width: 805;height:605;">
						</div>
		</td>
		<td width="200" style="vertical-align:top;text-align:right;">
			<div id="recommendations" style="width:200;height:600;display:inline;">

				User: <input type="text" id="username" value="dodijk" style="width: 120px;" onKeyDown="if(event.keyCode==13) xajax_loadProfile(document.getElementById('username').value);"></input><br />
				Artist: <input type="text" id="artist" value="Spinvis" style="width: 120px;" onKeyDown="if(event.keyCode==13) xajax_loadArtist(document.getElementById('artist').value);"></input><br />
				<div id="artists" name="artist">&#160;</div>				
				
			</div>
		</td>
	</tr>
	</table>

	<script type="text/javascript">
		// <![CDATA[
		var width 	= 805;
		var height 	= 605;

		var so = new SWFObject("http://www.fabchannel.com/embed/main2007.swf", "main", width, height, "8", "#FFFFFF", false,'high','','');

		so.addParam( "allowFullScreen", "true" );
		//so.addParam( "wmode" , "opaque" );
		so.write("flashcontent");
		// ]]>
	</script>
	
</body>
</html>

